<?php ini_set("display_errors", 1);
error_reporting(E_ALL);

session_start();

if ($_SERVER['QUERY_STRING'] == "logout") {
	
	session_destroy();
	$_SESSION = array();
	
}

$time_start = microtime(true);

$ini = parse_ini_file("config.ini");

$csrf_token = md5($ini["database"].$_SERVER['HTTP_USER_AGENT'].$_SERVER['REMOTE_ADDR']);

if (!file_exists($ini["database"].".sqlite")) {
	require "fct_create.php";
}

$db = new SQLite3($ini["database"].".sqlite");
$db->busyTimeout(5000);

/* ==================================================================== */


	function event() {
		
		global $db;
		global $ini;

		$res = $db->querySingle("SELECT event_id, title, logo, style
									FROM event
									WHERE active = 1", true);

			$event = $res["event_id"];
			$title = $res["title"];
			$logo = $res["logo"];
			$style = $res["style"];
		
		$res2 = $db->query("SELECT faction_id, title
					FROM eventfaction
					WHERE event_id = $event");
		
		while ($row = $res2->fetchArray()) {
		
			$factions[$row["faction_id"]] = $row["title"];
		}
		
		// TODO überprüfen ob gesetzt, sonst Werte aus config.ini
		
		return [ $event, $title, $logo, $style, $factions ];
	
	}
		
			
/* ==================================================================== */

				
$htmltitle = "Redeliste & Gruppen-Watch";
$group = array();
$error = "";


/* ==================================================================== */


	function htmlheader() {
		
		global $htmltitle;
		global $style;

		echo '<html lang="de">' . "\n" .
			'<head>' . "\n" .
			'<meta charset="utf-8">' . "\n" .
			'<link href="' . $style .'?modified='.time().'" rel="stylesheet">' . "\n" .
			'<meta name="ROBOTS" content="NONE">' . "\n" .
			'<meta name="viewport" content="width=device-width, initial-scale=1.0">' . "\n" .
			'<meta name="apple-mobile-web-app-capable" content="yes">' . "\n" .
			'<meta name="mobile-web-app-capable" content="yes">' . "\n" .
			'<title>' . $htmltitle . '</title>' . "\n" .
			'</head>' . "\n";

	}


/* ==================================================================== */


	function pageheader($page) {

	global $title;
	global $logo;
	
		echo '<header><div id="menu">';

		if ( $page != "index" ) { echo '<a href="index.php" title="Startseite / Wortmeldung"><button>🏠</button></a>'; }
		if ( $page != "view" ) { echo '<a href="view.php" title="Nur Auto-Redeliste anzeigen"><button>📺</button></a>'; }
		if ( $page != "stats" ) { echo '<a href="stats.php" title="Statistik"><button>📊</button></a>'; }
		
		if ( $page == "admin" && isset($_SESSION["loggedin"]) ) { echo '<a href="index.php?logout" title="Ausloggen"><button>💨</button></a>'; }
		elseif ( $page != "admin" ) { echo '<a href="admin.php" title="Admin"><button>🔧</button></a>'; }
		
	
	echo '</div><div id="header-element"><a href="index.php"><img src="img/' . $logo . '" id="logo"></a><br><a href="index.php">' . $title . '</a></div></header>';

	}
	
	
/* ==================================================================== */


	function discussion() {
		
		global $db;
		global $event;

		// Discussion_ID herausfinden

		// Geöffnete Diskussion vorhanden?
		$sql = "SELECT discussion_id, title, duration
					FROM discussion
					WHERE event_id = $event
					AND closed = 0";
		
		$res = $db->query($sql);
		
		while ($row = $res->fetchArray()) {
			
			$discussion = $row['discussion_id']; 
			$disc_title = $row['title']; 
			$disc_status = "open";
			
		}
		
		if (!isset($discussion)) {
			// TOdo wenn keine aktive, und wenn es überhaupt keine Diskussion gibt => eine anlegen?
			
			$sql = "SELECT discussion_id, title, duration
					FROM discussion
					WHERE event_id = $event
					AND (SELECT max(discussion_id) FROM discussion)";
			$res = $db->query($sql);		
			while ($row = $res->fetchArray()) {
			
			$discussion = $row['discussion_id']; 
			$disc_title = $row['title']; 
			$disc_status = "closed";
			
			}
			
			if (!isset($discussion)) {		
				$discussion = 0; 
				$disc_title = "Temporär"; 
				$disc_status = "open";
			}
		}

		return [ $discussion, $disc_title, $disc_status ];
	}


/* ==================================================================== */


	function durbars() {
		
		global $db;
		global $factions;
		global $discussion;
		 
		
		$duration_full = 1;
			
			foreach ($factions AS $fackey => $facval) {
											
				$duration_share[$fackey] = $db->querySingle("SELECT duration
											FROM timelog
											WHERE discussion_id = $discussion
											AND faction_id = $fackey 
											");
				$duration_full = $duration_full + $duration_share[$fackey];
			}
			// Tipp available_size/full = multiplier for each
		
		echo '<tr><td colspan="' . count($factions) . '" class="duration-bar">';

		foreach ($factions AS $fackey => $facval) {
			
			if ( $duration_share[$fackey] < 3600 ) {
					
					$redezeit = date("i\ms\s", $duration_share[$fackey]);
					
			} else { $redezeit = (int)($duration_share[$fackey] / 3600 ) . date("\hi\ms\s", $duration_share[$fackey]); } // notwendiger Hack, damit Umstellung Sommer-Winterzeit nicht falsches Ergebnis bringt
			
			
			$barlength = 355/$duration_full * $duration_share[$fackey]; // ToDo Balkenlänge in Javascript berechnen, wg. window.innerWidth
			if ($barlength == 0) { $redezeit = ""; } 
		
			echo '<div style="width: ' . $barlength . 'px;" title="Redezeit ' . $facval . ': ' . $redezeit . '" class="duration-bar direction' . $fackey . '">&nbsp;' . $redezeit . '&nbsp;</div>';
		
		}
	  	  
		echo '</td></tr>';
	  	  
	 }
	 
	   
/* ==================================================================== */


	function pagefooter() {
		
		global $time_start;
		
		$time = microtime(true) - $time_start;
		
		//echo '<footer><a href="info.php">Info</a> · <a href="info.php#datenschutz">Datenschutz</a> · <a href="info.php#impressum">Impressum</a> · ' . $time . '</footer>'; // nur development
		echo '<footer><a href="info.php">Info</a> · <a href="info.php#datenschutz">Datenschutz</a> · <a href="info.php#impressum">Impressum</a></footer>';
	}


/* ==================================================================== */


	function loginform() {
		
		global $ini;
		global $csrf_token;
		
		echo '
		  <main>
		  
			<h1>Bitte einloggen</h1>
			
			<p>Zum Testen kann das Login-Passwort <b>'.$ini["password"].'</b> verwendet werden.</p>
			
			<form enctype="application/x-www-form-urlencoded" method="post" action="admin.php" name="login">
			<input name="pwd" id="pwd" value="" placeholder="Passwort" maxlength="40" type="password">
			<input name="token" value="' . $csrf_token . '" id="token" type="hidden">
			<input name="submit" id="submit" value="Einloggen" type="submit">
			</form>
			 	  
		  </main>';	
		
	}



/* ==================================================================== */

	//Todo um temporär Einträge zu user agents zu erzeugen

	$sql = "SELECT COUNT(*) AS count
					FROM blocklist
					WHERE ip LIKE '" . $_SERVER["REMOTE_ADDR"]. "'
					AND browser LIKE '". $_SERVER["HTTP_USER_AGENT"]. "'";
			$res = $db->querySingle($sql);

		if ($res == 0) {
			
			$db->exec("INSERT INTO blocklist (
			   event_id, 
			   ip, 
			   browser,
			   added
			   ) VALUES (
			   '1', 
			   '" . $_SERVER["REMOTE_ADDR"]. "', 
			   '" . $_SERVER["HTTP_USER_AGENT"]. "',
			   '".time()."'
			   )");
	   
		}
   
/* ==================================================================== */



	function cln($string, $length) {
		mb_strlen($string);
		echo substr('abcdef', 0, 4);  // abcd
		
	} // TODO: not used yet
