<?php 

$db = new SQLite3($ini["database"].".sqlite");

/* Tabelle WAITING (Liste der Wortmeldungen)
 * 
 * faction_id: standardmäßig 1=weiblich, 2=männlich, 3=anders
 * status: 0=auf Warteliste, 1=spricht, 2=hat gesprochen, 3=zurückgezogen/gelöscht
 * 
 */
 
$db-> exec("CREATE TABLE IF NOT EXISTS waiting (
   waiting_id INTEGER PRIMARY KEY AUTOINCREMENT,
   discussion_id INTEGER NOT NULL DEFAULT '0',
   person TEXT NOT NULL DEFAULT '',
   organisation TEXT NOT NULL DEFAULT '',
   faction_id INTEGER NOT NULL DEFAULT '0',
   status INTEGER NOT NULL DEFAULT '0',
   session TEXT NOT NULL DEFAULT '',  
   created INTEGER NOT NULL DEFAULT '0',
   started INTEGER NOT NULL DEFAULT '0',
   duration INTEGER NOT NULL DEFAULT '0')"); 

$db-> exec("CREATE TABLE IF NOT EXISTS discussion (
   discussion_id INTEGER PRIMARY KEY AUTOINCREMENT,
   event_id INTEGER NOT NULL DEFAULT '0',
   title TEXT NOT NULL DEFAULT '',
   created INTEGER NOT NULL DEFAULT '0',
   duration INTEGER NOT NULL DEFAULT '0',
   closed INTEGER NOT NULL DEFAULT '0')");
   
$db-> exec("CREATE TABLE IF NOT EXISTS timelog (
   timelog_id INTEGER PRIMARY KEY AUTOINCREMENT,
   discussion_id INTEGER NOT NULL DEFAULT '0',
   faction_id INTEGER NOT NULL DEFAULT '0',
   duration INTEGER NOT NULL DEFAULT '0',
   last_update INTEGER NOT NULL DEFAULT '0'
	)");
   
$db->exec("INSERT INTO discussion (
   discussion_id,
   event_id, 
   title, 
   created,
   duration,
   closed
   ) VALUES (
   '1', 
   '1', 
   'Loslegen',
   '".time()."',
   '0',
   '0'
   )");
   
$db->exec("INSERT INTO timelog (
   discussion_id,
   faction_id, 
   last_update
   ) VALUES (
   '1', 
   '1', 
   '".time()."'
   )");
   
$db->exec("INSERT INTO timelog (
   discussion_id,
   faction_id, 
   last_update
   ) VALUES (
   '1', 
   '2', 
   '".time()."'
   )");

/* Tabelle EVENT (Alle Events und deren Settings)
 * 
 * prio: 0 = nach Zeitpunkt der Meldung
 * 		1 = nach Faction
 * 		2 = nach Faction, innerhalb nach Erstrederecht
 * 		3 = nach Erstrederecht, dann nach Faction
 */
  
$db->exec("CREATE TABLE IF NOT EXISTS event (
   event_id INTEGER PRIMARY KEY AUTOINCREMENT,
   title TEXT NOT NULL DEFAULT '',
   logo TEXT NOT NULL DEFAULT '',
   style TEXT NOT NULL DEFAULT '',
   prio INTEGER NOT NULL DEFAULT '0',
   active INTEGER NOT NULL DEFAULT '1'
   )");

$db-> exec("CREATE TABLE IF NOT EXISTS eventfaction (
   eventfaction_id INTEGER PRIMARY KEY AUTOINCREMENT,
   event_id INTEGER NOT NULL DEFAULT '0',
   faction_id INTEGER NOT NULL DEFAULT '0',
   title TEXT NOT NULL DEFAULT ''
   )");

$db->exec("INSERT INTO event (
	title,
	logo,
	style,
	prio,
	active
	) VALUES (
	'Veranstaltung<br>am ".date("d.m.Y")."',
	'logo_temp.svg',
	'style.css',
	'2',
	'1'
	)");

$db->exec("INSERT INTO eventfaction (
	event_id,
	faction_id,
	title
	) VALUES (
	'1',
	'1',
	'♀'
	)");

$db->exec("INSERT INTO eventfaction (
	event_id,
	faction_id,
	title
	) VALUES (
	'1',
	'2',
	'♂'
	)");
	
/* $db->exec("INSERT INTO eventfaction (
	event_id,
	faction_id,
	title
	) VALUES (
	'1',
	'3',
	'⚧'
	)");
*/   
$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'Kathryn Janeway', 
   'Sternenflotte',
   '1',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");
   
$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'B&#039;Elanna Torres', 
   'Maquis',
   '1',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");

$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'Chakotay', 
   'Maquis',
   '2',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");

$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'Tuvok', 
   'Sternenflotte',
   '2',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");

$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'Seven of Nine', 
   'Borg',
   '1',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");
   
$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'Deanna Troi', 
   'Sternenflotte',
   '1',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");

$db->exec("INSERT INTO waiting (
   discussion_id, 
   person, 
   organisation,
   faction_id,
   status,
   session,
   created) VALUES (
   '1', 
   'Jean-Luc Picard', 
   'Sternenflotte',
   '2',
   '0',
   '".md5(microtime())."',
   '".time()."'
   )");

$db->exec("CREATE TABLE IF NOT EXISTS blocklist (
   blocklist_id INTEGER PRIMARY KEY AUTOINCREMENT,
   event_id INTEGER NOT NULL DEFAULT '0',
   ip TEXT NOT NULL DEFAULT '',
   browser TEXT NOT NULL DEFAULT '',
   added TEXT NOT NULL DEFAULT ''
   )");

$db->exec("INSERT INTO blocklist (
   event_id, 
   ip, 
   browser,
   added
   ) VALUES (
   '1', 
   '" . $_SERVER["REMOTE_ADDR"]. "', 
   '" . $_SERVER["HTTP_USER_AGENT"]. "',
   '".time()."'
   )");
